#include <stddef.h>
#include <zephyr/kernel.h>
#include <zephyr/logging/log.h>
#include <zephyr/sys/printk.h>
#include <zephyr/sys/util.h>
#include <zephyr/types.h>

#include <zephyr/drivers/gpio.h>

#include "tilt.h"

#define LED0_NODE DT_ALIAS(led0)
static const struct gpio_dt_spec led = GPIO_DT_SPEC_GET(LED0_NODE, gpios);

#define LED1_NODE DT_ALIAS(supply)
static const struct gpio_dt_spec supply = GPIO_DT_SPEC_GET(LED1_NODE, gpios);

#define LED2_NODE DT_ALIAS(cs)
static const struct gpio_dt_spec i2c_on = GPIO_DT_SPEC_GET(LED2_NODE, gpios);

#define LED3_NODE DT_ALIAS(lsb)
static const struct gpio_dt_spec lsb_sens = GPIO_DT_SPEC_GET(LED3_NODE, gpios);

// #define SW0_NODE DT_ALIAS(sw0)
// static const struct gpio_dt_spec button = GPIO_DT_SPEC_GET(SW0_NODE, gpios);
// static struct gpio_callback button_cb_data;

LOG_MODULE_REGISTER(main);


int main(void) {

  gpio_is_ready_dt(&led);
	gpio_pin_configure_dt(&led, GPIO_OUTPUT_ACTIVE);

  gpio_is_ready_dt(&i2c_on);
	gpio_pin_configure_dt(&i2c_on, GPIO_OUTPUT_ACTIVE);
  gpio_pin_set_dt(&i2c_on, 1);

  gpio_is_ready_dt(&lsb_sens);
	gpio_pin_configure_dt(&lsb_sens, GPIO_OUTPUT_ACTIVE);
  gpio_pin_set_dt(&lsb_sens, 1);

  gpio_is_ready_dt(&supply);
	gpio_pin_configure_dt(&supply, GPIO_OUTPUT_ACTIVE);
  gpio_pin_set_dt(&supply, 1);


  tilt_check_sensor();

  // tilt_run();

  while (1) {
    printk("Running\n");

    gpio_pin_toggle_dt(&led);

    k_sleep(K_SECONDS(1));
  }

  return 0;
}